{$A+,B+,D-,E+,F+,I+,L+,N-,O+,R-,S+,V-}
unit mesgup;

interface

uses
  crt, dos, overlay,
  common,timejunk;

var
  sx,sy:integer;
  wascls,savtw:boolean;
  savcurwind:integer;

procedure execbatch(var ok:boolean; showit:boolean;
                    bfn,tfn,dir,batline:astr; oklevel:integer);
procedure pexecbatch(showit:boolean; bfn,tfn,dir,batline:astr;
                     var retlevel:integer);
procedure shel(s:astr);
procedure shel1;
procedure shel2;
procedure bproline(var cline:astr; filespec:astr);
function bproline2(cline:astr):astr;
function substall(src,old,new:astr):astr;
function bproline1(cline:astr):astr;
function rte:real;
procedure star(s:astr);
procedure recvascii(fn:astr; var dok:boolean; tpb:real);
function findprot(cs:astr; ul,dl,batch,resume:boolean):integer;
function okprot(prot:protrec; ul,dl,batch,resume:boolean):boolean;
procedure showprots(ul,dl,batch,resume:boolean);
procedure mpkey(var s:astr);
procedure receive1(fn:astr; resumefile:boolean; var dok,kabort,addbatch:boolean);

implementation

procedure execbatch(var ok:boolean;     { result                     }
                    showit:boolean;     { show working on user side  }
                    bfn:astr;           { .BAT filename              }
                    tfn:astr;           { temporary testing file     }
                    dir:astr;           { directory takes place in   }
                    batline:astr;       { .BAT file line to execute  }
                    oklevel:integer);   { DOS errorlevel for success }
var bfp:text;
    odir,todev:astr;
    i,rcode:integer;
begin
  todev:=' >nul';
  if ((showit) and (incom)) then
    todev:=' >'+systat.remdevice+' <'+systat.remdevice
  else
    if (wantout) then todev:=''; {' >con';}

  getdir(0,odir);
  dir:=fexpand(dir);
  while copy(dir,length(dir),1)='\' do dir:=copy(dir,1,length(dir)-1);
  assign(bfp,bfn);
  rewrite(bfp);
  writeln(bfp,'echo off');
  writeln(bfp,chr(exdrv(dir)+64)+':');
  writeln(bfp,'cd '+dir);
  writeln(bfp,batline+todev);
  writeln(bfp,':done');
  writeln(bfp,chr(exdrv(odir)+64)+':');
  writeln(bfp,'cd '+odir);
  writeln(bfp,'exit');
  close(bfp);

  if (wantout) then begin
    tc(15); textbackground(1); clreol; write(batline); clreol;
    tc(7); textbackground(0); writeln;
  end;
{  if (todev=' >con') then todev:='' else todev:=' >nul';}

  shelldos(FALSE,bfn+todev,rcode);

  chdir(odir);
  {$I-} erase(bfp); {$I+}
  if (oklevel<>-1) then ok:=(rcode=oklevel) else ok:=TRUE;
end;

procedure pexecbatch(showit:boolean;     { show working on user side  }
                     bfn:astr;           { .BAT filename              }
                     tfn:astr;           { UNUSED -----------         }
                     dir:astr;           { directory takes place in   }
                     batline:astr;       { .BAT file line to execute  }
                 var retlevel:integer);  { DOS errorlevel returned    }
var tfp,bfp:text;
    odir,todev:astr;
begin
  todev:=' >nul';
  if (showit) and (incom) then
    todev:=' >'+systat.remdevice+' <'+systat.remdevice
  else
    if (wantout) then todev:=' >con';

  getdir(0,odir);
  dir:=fexpand(dir);
  while copy(dir,length(dir),1)='\' do dir:=copy(dir,1,length(dir)-1);
  assign(bfp,bfn);
  rewrite(bfp);
  writeln(bfp,'echo off');
  writeln(bfp,chr(exdrv(dir)+64)+':');
  writeln(bfp,'cd '+dir);
  writeln(bfp,batline+todev);
  writeln(bfp,':done');
  writeln(bfp,chr(exdrv(odir)+64)+':');
  writeln(bfp,'cd '+odir);
  writeln(bfp,'exit');
  close(bfp);

  if (wantout) then begin
    tc(15); textbackground(1); clreol; write(batline); clreol;
    tc(7); textbackground(0); writeln;
  end;
  if (todev=' >con') then todev:='' else todev:=' >nul';

  shelldos(FALSE,bfn+todev,retlevel);

  chdir(odir);
  {$I-} erase(bfp); {$I+}
end;

procedure shel(s:astr);
begin
  wascls:=FALSE;
  savcurwind:=systat.curwindow;
  if (s<>'') then begin
    wascls:=TRUE;
    sx:=wherex; sy:=wherey;
    {setwindow(wind,1,1,80,25,7,0,0);}
    clrscr;
    textbackground(1); tc(15); clreol;
    write(s);
    textbackground(0); tc(7); writeln;
  end else
    if (savcurwind<>0) then sclearwindow;
{      if (not systat.istopwindow) then sclearwindow;}
end;

procedure shel1;
begin
  shel('');
end;

procedure shel2;
begin
  if (wascls) then begin
    clrscr;
    gotoxy(sx,sy);
    topscr;
  end else
    if (savcurwind<>0) then schangewindow(TRUE,savcurwind);
end;

procedure bproline(var cline:astr; filespec:astr);
const lastpos:integer=-1;
begin
  if (pos('%F',cline)<>0) then begin
    lastpos:=pos('%F',cline)+length(filespec);
    cline:=substall(cline,'%F',filespec);
  end else begin
    insert(' '+filespec,cline,lastpos);
    inc(lastpos,length(filespec)+1);
  end;
end;

function bproline2(cline:astr):astr;
var s:astr;
begin
  s:=substall(cline,'%C',start_dir);
  s:=substall(s,'%G',copy(systat.gfilepath,1,length(systat.gfilepath)-1));
  bproline2:=s;
end;

function substall(src,old,new:astr):astr;
var p:integer;
begin
  p:=1;
  while p>0 do begin
    p:=pos(old,src);
    if p>0 then begin
      insert(new,src,p+length(old));
      delete(src,p,length(old));
    end;
  end;
  substall:=src;
end;

function bproline1(cline:astr):astr;
var s,s1:astr;
begin
  if ((not incom) and (not outcom)) then s1:=cstrl(modemr.waitbaud) else s1:=spd;
  s:=substall(cline,'%B',s1);
  s:=substall(s,'%L',bproline2(protocol.dlflist));
  s:=substall(s,'%P',cstr(modemr.comport));
  s:=substall(s,'%T',bproline2(protocol.templog));
  bproline1:=bproline2(s);
end;

function rte:real;
var i:integer;
begin
  i:=value(spd); if (i=0) then i:=modemr.waitbaud;
  rte:=1400.0/i;
end;

procedure star(s:astr);
begin
  cl(4); if (okansi) then prompt(' ') else prompt('* ');
  cl(3); if (s<>#1) then sprint(s);
end;

procedure recvascii(fn:astr; var dok:boolean; tpb:real);
var f:file;
    r1:array[0..1023] of byte;
    byte_count,start_time:longint;
    bytes_this_line,kbyte_count,line_count:integer;
    b:byte;
    start,abort,error,done,timeo,kba,prompti:boolean;
    c:char;

(*    procedure onec(var b:byte);
    var r:real;
        i:byte;
        c:char;
        bb:boolean;
    begin
      if (inhead[modemr.comport]<>intail[modemr.comport]) then begin
        bb:=recom1(c);
        b:=ord(c);
      end else begin
        r:=timer;
        while (not async_buffer_check) and (tchk(r,90.0)) do checkhangup;
        if (async_buffer_check) then b:=ord(ccinkey1)
        else begin
          timeo:=TRUE;
          b:=0;
        end;
        if (timeo) then error:=TRUE;
        if (hangup) then begin
          error:=TRUE; done:=TRUE;
          abort:=TRUE;
        end;
      end;
    end;*)

    procedure checkkb;
    var c:char;
    begin
      if (keypressed) then begin
        c:=readkey;
        if (c=#27) then begin
          abort:=TRUE; done:=TRUE; kba:=TRUE;
          nl; star('Aborted.');
        end;
      end;
    end;

begin
  abort:=FALSE; done:=FALSE; timeo:=FALSE; kba:=FALSE;
  line_count:=0; start:=FALSE;
  start_time:=trunc(timer); byte_count:=0;
  assign(f,fn);
  {$I-} rewrite(f,1); {$I+}
  if (ioresult<>0) then begin
    if (useron) then star('Disk error -  sorry, unable to upload it.');
    done:=TRUE; abort:=TRUE;
  end;
  prompti:=pynq('Do you want prompted input? [No] ');
  if (useron) then star('Upload ASCII text.  Press Ctrl-Z (^Z) when done');
  while (not done) and (not hangup) do begin
    error:=TRUE;
    checkkb;
    if (kba) then begin
      done:=TRUE;
      abort:=TRUE;
    end;
    if (not kba) then
      if (prompti) then begin
        com_flush_rx;
        sendcom1('>');
      end;
    if (not done) and (not abort) and (not hangup) then begin
      start:=FALSE;
      error:=FALSE;
      checkkb;
      if (not done) then begin
        bytes_this_line:=0;
        repeat
          getkey(c); b:=ord(c);
          if (b=26) then begin
            start:=TRUE; done:=TRUE;
            nl;
            if (useron) then star('End Of File Received');
          end else begin
            if (b<>10) then begin         (* ignore LF *)
              r1[bytes_this_line]:=b;
              bytes_this_line:=bytes_this_line+1;
            end;
          end;
        until (bytes_this_line>250) or (b=13) or (timeo) or (done);
        if (b<>13) then begin
          r1[bytes_this_line]:=13;
          bytes_this_line:=bytes_this_line+1;
        end;
        r1[bytes_this_line]:=10;
        bytes_this_line:=bytes_this_line+1;
        seek(f,byte_count);
        {$I-} blockwrite(f,r1,bytes_this_line); {$I+}
        if (ioresult<>0) then begin
          nl;
          if (useron) then star('Disk error');
          done:=TRUE; abort:=TRUE;
        end;
        inc(line_count);
        byte_count:=byte_count+bytes_this_line;
      end;
    end;
  end;
  close(f);
  kbyte_count:=0;
  while (byte_count>1024) do begin
    inc(kbyte_count);
    byte_count:=byte_count-1024;
  end;
  if (byte_count>512) then inc(kbyte_count,1);
  if (hangup) then abort:=TRUE;
  if (abort) then erase(f)
  else begin
    star(cstr(line_count)+' lines, '+cstr(kbyte_count)+'k uploaded');
    if (timer<start_time) then start_time:=start_time-24*60*60;
  end;
  dok:=not abort;
end;

function findprot(cs:astr; ul,dl,batch,resume:boolean):integer;
var s:astr;
    i:integer;
    done:boolean;
begin
  findprot:=-99;
  if (cs='') then exit;
  seek(xf,0);
  done:=FALSE; i:=0;
  while ((i<=filesize(xf)-1) and (not done)) do begin
    read(xf,protocol);
    with protocol do
      if (cs=ckeys) then
        if (okprot(protocol,ul,dl,batch,resume)) then begin
          if (ul) then s:=ulcmd else if (dl) then s:=dlcmd else s:='';
          if (s='ASCII') then begin done:=TRUE; findprot:=-1; end
          else if (s='QUIT') then begin done:=TRUE; findprot:=-10; end
          else if (s='NEXT') then begin done:=TRUE; findprot:=-11; end
          else if (s='BATCH') then begin done:=TRUE; findprot:=-12; end
          else if (s<>'') then begin done:=TRUE; findprot:=i; end;
        end;
    inc(i);
  end;
end;

function okprot(prot:protrec; ul,dl,batch,resume:boolean):boolean;
var s:astr;
begin
  okprot:=FALSE;
  with prot do begin
    if (ul) then s:=ulcmd else if (dl) then s:=dlcmd else s:='';
    if (s='NEXT') and ((ul) or (batch) or (resume)) then exit;
    if (s='BATCH') and ((batch) or (resume)) then exit;
    if (batch<>(xbisbatch in xbstat)) then exit;
    if (resume<>(xbisresume in xbstat)) then exit;
    if (not (xbactive in xbstat)) then exit;
    if (not aacs(acs)) then exit;
    if (s='') then exit;
  end;
  okprot:=TRUE;
end;

procedure showprots(ul,dl,batch,resume:boolean);
var s:astr;
    i:integer;
    abort,next:boolean;
begin
  nofile:=TRUE;
  if (resume) then printf('protres')
  else begin
    if (batch) and (ul) then printf('protbul');
    if (batch) and (dl) then printf('protbdl');
    if (not batch) and (ul) then printf('protsul');
    if (not batch) and (dl) then printf('protsdl');
  end;
  if (nofile) then begin
    seek(xf,0);
    abort:=FALSE; next:=FALSE; i:=0;
    while ((i<=filesize(xf)-1) and (not abort)) do begin
      read(xf,protocol);
      if (okprot(protocol,ul,dl,batch,resume)) then sprint(protocol.descr);
      if (not empty) then wkey(abort,next);
      inc(i);
    end;
  end;
end;

procedure mpkey(var s:astr);
var sfqarea,smqarea:boolean;
begin
  sfqarea:=fqarea; smqarea:=mqarea;
  fqarea:=FALSE; mqarea:=FALSE;

  mmkey(s);

  fqarea:=sfqarea; mqarea:=smqarea;
end;

procedure receive1(fn:astr; resumefile:boolean; var dok,kabort,addbatch:boolean);
var cp,nfn,s:astr;
    st:real;
    filsize:longint;
    p,i,t,fno,sx,sy,nof,errlevel:integer;
    c:char;
    b,done1,foundit:boolean;
begin
  done1:=FALSE;
  reset(xf);
  repeat
    nl;
    sprompt('^4Transfer Protocol [^0?^4=^0List^4]  ^3'); mpkey(s);
    if (s='?') then begin
      nl;
      showprots(TRUE,FALSE,FALSE,resumefile);
    end else begin
      p:=findprot(s,TRUE,FALSE,FALSE,resumefile);
      if (p=-99) then print('Invalid entry.') else done1:=TRUE;
    end;
  until (done1) or (hangup);

  if (not useron) then 
  begin 
    incom:=TRUE; 
    outcom:=TRUE; 
  end;
  dok:=TRUE; 
  kabort:=FALSE;
  if (p>=0) then 
  begin 
    seek(xf,p); 
    read(xf,protocol); 
  end;
  close(xf);
  case p of
   -12:addbatch:=TRUE;
   -11,-10:begin 
             dok:=FALSE; 
             kabort:=TRUE; 
           end;
   -1:if (not trm) then recvascii(fn,dok,rte);
  else
      if (incom) then begin
        cp:=bproline1(protocol.ulcmd);
        bproline(cp,sqoutsp(fn));

        b:=systat.swapshell; systat.swapshell:=FALSE;
        pexecbatch(FALSE,'tgtemp2.bat','tgtest2.$$$',start_dir,cp,errlevel);
        systat.swapshell:=b;
        shel2;

        foundit:=FALSE; 
        i:=0;
        while ((i<6) and (not foundit)) do begin
          inc(i);
          if (value(protocol.ulcode[i])=errlevel) then foundit:=TRUE;
        end;

        dok:=TRUE;
        if ((foundit) and (not (xbxferokcode in protocol.xbstat))) then dok:=FALSE;
        if ((not foundit) and (xbxferokcode in protocol.xbstat)) then dok:=FALSE;
      end;
  end;
  if (not useron) and (not kabort) then begin
    {cursoron(FALSE);
    gotoxy(3,2); 
    tc(14); }
    if (dok) then write('Transfer successful.') else
      write('Transfer unsuccessful.');
    
    {st:=timer;
    while (not keypressed) and (tcheck(st,5)) do abeep;
    if (keypressed) then c:=readkey;
    cursoron(TRUE);}
    incom:=FALSE; 
    outcom:=FALSE;
  end;
end;

end.
